config/routes.rb
Rails.application.routes.draw do
  resources :notes
  get 'statistics/show'
  get 'pages/no_project'
  get 'calendar/show'
  get 'pages/home'

  devise_for :users

  resources :projects do
    resources :tasks do
      resources :allocated_times do
        member do
          post :complete
          post :ignore
        end
      end

      member do
        post :complete
        post :uncomplete
      end
    end
  end

  root to: 'pages#home'
end

app/models/task.rb
class Task < ApplicationRecord
  belongs_to :project
  belongs_to :user
  has_many :allocated_times, dependent: :destroy
  default_scope -> { order(deadline: :asc) }
  scope :done, -> () { where(done: true) }
  validates :user_id, presence: true
  validates :project_id, presence: true
  validates :name, presence: true, length: { maximum: 100 }
  acts_as_taggable
end

app/controllers/tasks_controller.rb
class TasksController < ApplicationController
  load_and_authorize_resource
  before_action :set_task, only: [:edit, :update, :destroy, :complete]
  before_action :set_project

  def new
    @task = Task.new
  end

  def show
  end

  def edit
  end

  def complete
    if @task.update_attributes(done: true)
      flash[:success] = 'Task completed'
    end
    redirect_to @project
  end

  def uncomplete
    if @task.update_attributes(done: false)
      flash[:success] = 'Task completed'
    end
    redirect_to @project
  end

  def update
    if @task.update(task_params)
      flash[:success] = 'Task edited'
      redirect_to @project
    else
      render 'edit'
    end
  end

  def create
    @task = @project.tasks.create(task_params)
    @task.user_id = current_user.id
    if @task.save
      flash[:success] = "Task created"
      redirect_to @project
    else
      flash[:danger] = 'Task not created'
      render 'new'
    end
  end

  def destroy
    @task.destroy
    flash[:success] = "Task deleted"
    redirect_to @project
  end

  private
    def set_task
      @task = Task.find(params[:id])
    end

    def set_project
      @project = Project.find(params[:project_id])
    end

    def task_params
      params.require(:task).permit(:project, :user, :name, :description, :deadline, :show_all, :tag_list)
    end
end

app/helpers/tasks_helper.rb
module TasksHelper
end

app/views/tasks/_form.html.slim
=simple_form_for [@project, task] do |f|
  div class="form-inputs"
    =f.input :name, required: true, autofocus: true
    =f.input :description, required: false
    =f.input :deadline, required: true
    =f.input :tag_list, label: "Tags (separated by commas)"
  div class="form-actions"
    =f.button :submit, "Save Task"

app/views/tasks/_task.html.slim
div class="panel panel-default" id="task-=task.id"
  div class="panel-heading"
      h4 class="task_name" id="task_name_#{task.done}"
        =task.name
      div id="tags_show"
        -task.tag_list.each do |t|
          =link_to "##{t}", project_path(@project, show_all: true, tag: t)
          ="  "
      - deadline_status = "ok"
      - if Date.today > task.deadline
        -deadline_status = "past"
      -elsif Date.today.days_since(7) > task.deadline
        -deadline_status = "soon"
      div class="task-deadline task-deadline-#{deadline_status}"
        =task.deadline.strftime("Until %d. %m. %Y")
      div id="task-desc"
        =task.description
      div
        -if task.done != true
          =link_to "Complete", complete_project_task_path(@project, task), method: :post, class: "btn btn-success btn-sm"
        -else
          =link_to "Uncomplete", uncomplete_project_task_path(@project, task), method: :post, class: "btn btn-danger btn-sm"
        =link_to "Allocate Time", new_project_task_allocated_time_path(@project, task), class: "btn btn-primary btn-sm"
        =link_to "Edit", edit_project_task_path(@project, task), class: "btn btn-info btn-sm"
        =link_to "Delete", project_task_path(@project, task), method: :delete, data: { confirm: 'Are you sure?' }, class: 'btn btn-warning btn-sm'
  -if (@show_all and task.allocated_times.any?) or (!@show_all and task.allocated_times.where(ignored: nil).any?)
    div class="panel-body"
      table class="table"
        -if @show_all
          =render task.allocated_times, task: task
        -else
          =render task.allocated_times.where(ignored: nil), task: task

app/views/tasks/edit.html.slim
h1 Edit Task
=render 'tasks/form', task: @task
=link_to 'Back', :back

app/views/tasks/index.html.slim
div
  h2 id="project-name"
    =@project.name
  div id="tag-cloud"
    -@tags.each do |t|
      =link_to "##{t}", project_path(@project, show_all: true, tag: t.name)
      ="  "
  div class="project-btns"
    =link_to 'New Task', new_project_task_path(@project), class: "btn btn-primary"
    -if @show_all
      =link_to 'Reset view', project_path(@project), class: "btn btn-default"
    -else
      =link_to 'Show all', project_path(@project, show_all: true), class: "btn btn-default"
    =link_to "Rename Project", edit_project_path(@project), class: "btn btn-info"
    =link_to "Delete Project", @project, method: :delete, data: { confirm: 'Are you sure?' }, class: 'btn btn-warning'
  section class="task_list"
    -if @tasks.any?
      =render @tasks

app/views/tasks/new.html.slim
h1 New Task
=render 'tasks/form', task: @task
=link_to 'Back', :back